clear
clc
close all
echo off
format long
disp('///////////////////////////////////////////////////////////////////////////')
disp('..')
disp(' Usamos 9 Bits para un rango de 0 a 511')                              
disp(' La funcin es                         ')
peaks

vida=200;
vida = input(' Qu cantidad de generaciones desea? : ');
if vida <= 0
   error('Usted ingres un valor menor o igual a cero para la cantidad de generaciones')
   else
end
   
disp(' Se usa elitismo, y el individuo ELITE ocupa el lugar GenX(:,1) y GenY(:,1)')
disp(' Resolucin de problema bi-variado')
GenX= (RANDOM('Discrete Uniform',2,9,4)) - ones(9,4);
GenY= (RANDOM('Discrete Uniform',2,9,4)) - ones(9,4);
% seteo y configuro

GenXEliteBin=GenX(:,1);
GenYEliteBin=GenY(:,1);
GenEliteValue=-inf;
temporal=zeros(vida,3);
% inicio del ciclo
for ciclo=1:vida;
 
  
% Calculo el valor en decimal de cada gen
for m=1:4;
   GenXValue(m) = (0.01*((GenX(9,m)* 1) + (GenX(8,m) * 2) + (GenX(7,m) * 4) + (GenX(6,m) * 8) + (GenX(5,m) * 16) + (GenX(4,m) * 32) + (GenX(3,m) * 64) + (GenX(2,m) * 128) + (GenX(1,m) * 256)))-2.56;
   GenYValue(m) = (0.01*((GenY(9,m)* 1) + (GenY(8,m) * 2) + (GenY(7,m) * 4) + (GenY(6,m) * 8) + (GenY(5,m) * 16) + (GenY(4,m) * 32) + (GenY(3,m) * 64) + (GenY(2,m) * 128) + (GenY(1,m) * 256)))-2.56;
end

% Usando la funcin, encuentro el resultado para cada gen
for m=1:4;
   % Result(m) = (40*GenValue(m)) - (GenValue(m)^2);
   Result(m) = 3*(1-GenXValue(m)).^2.*exp(-(GenXValue(m).^2) - (GenYValue(m)+1).^2) - 10*(GenXValue(m)/5 - GenXValue(m).^3 - GenYValue(m).^5).*exp(-GenXValue(m).^2-GenYValue(m).^2) - 1/3*exp(-(GenXValue(m)+1).^2 - GenYValue(m).^2);
	if Result(m) > GenEliteValue
   	GenEliteValue=Result(m);
		GenXEliteBin = GenX(:,m);   		
      GenYEliteBin = GenY(:,m);
      GenElite = m;   
   else
	end 
end

% Resultado total...
Resultotal = Result(1) + Result(2) + Result(3) + Result(4); 

% Fitness de cada gen
for m=1:4;
Peso(m)= Result(m) * 1000 / Resultotal; 
end

% Reproduccin, reproducir cada string in la nueva poblacin proporcionalmente a su contrubucin en la suma
for m=1:4;
r = RANDOM('Discrete Uniform',1000,1,1);
if r <= Peso(1) 
   for i=1:9
   GenX(i,m)=GenX(i,1);
   GenY(i,m)=GenY(i,1);
   end
elseif r <= Peso(1)+Peso(2)
   for i=1:9
      GenX(i,m)=GenX(i,2);
      GenY(i,m)=GenY(i,2);
	end
elseif r <= Peso(1)+Peso(2)+Peso(3)
   for i=1:9
      GenX(i,m)=GenX(i,3);
      GenY(i,m)=GenY(i,3);
	end
else 
   for i=1:9
   	GenX(i,m)=GenX(i,4);
   	GenY(i,m)=GenY(i,4);
   end
end
end

%Elitismo
GenX(:,1)=GenXEliteBin;
GenY(:,1)=GenXEliteBin;

% Crossover
puntocruce1 = RANDOM('Discrete Uniform',9,1,1);
% Gen 1
% Backup
for m=1:4;
for i=1:9;
   GenXBackUp(i,m)=GenX(i,m);
   GenYBackUp(i,m)=GenY(i,m);
end
end

%Crossover para gen 1
for i=1:9;
   if i<=puntocruce1
      GenX(i,1) = GenXBackUp(i,2);
      GenY(i,1) = GenYBackUp(i,2);
   else
   end
end

%Crossover para gen 2
for i=1:9;
   if i<=puntocruce1
      GenX(i,2) = GenXBackUp(i,1);
      GenY(i,2) = GenYBackUp(i,1);
   else
   end
end


puntocruce2 = RANDOM('Discrete Uniform',9,1,1);

%Crossover para gen 3
for i=1:9;
   if i<=puntocruce2;
      GenX(i,3) = GenXBackUp(i,4);
      GenY(i,3) = GenYBackUp(i,4);
   else
   end
end

%Crossover para gen 4
for i=1:9;
   if i<=puntocruce2;
      GenX(i,4) = GenXBackUp(i,3);
      GenY(i,4) = GenYBackUp(i,3);
   else
   end
end

% Elitismo
GenX(:,1)=GenXEliteBin;
GenY(:,1)=GenYEliteBin;

% Mutacin
 puntomutacion = RANDOM('Discrete Uniform',9,1,1);
 genmutado = RANDOM('Discrete Uniform',3,1,1);
 GenX(puntomutacion,genmutado+1)=1-GenX(puntomutacion,genmutado+1);
 
 puntomutacion = RANDOM('Discrete Uniform',9,1,1);
 genmutado = RANDOM('Discrete Uniform',3,1,1);
 GenY(puntomutacion,genmutado+1)=1-GenY(puntomutacion,genmutado+1);
 
temporal(ciclo,1)=GenXValue(1);
temporal(ciclo,2)=GenYValue(1);
temporal(ciclo,3)=GenEliteValue(1);
end

lll=1:1:vida;
figure,plot(lll,temporal(lll,1),'b',lll,temporal(lll,2),'r',lll,temporal(lll,3)/3,'k'),xlabel('Generaciones'),ylabel('Mximo Maximorum  Elite')
legend('Valor de X','Valor de Y','Valor de Z(X,Y)/3',0);
TITLE(GenEliteValue)
% figure,plot(lll,P(1)*temporal(lll).^4 + P(2)*temporal(lll).^3 + P(3)*temporal(lll).^2 + P(4)*temporal(lll) + P(5)),xlabel('Generaciones'),ylabel('Y Mximo Maximorum  Elite')

disp(' --------------------------------')
disp(' Resultados')
disp('X :')
disp(GenXValue(1))
disp('Y :')
disp(GenYValue(1))
disp('Z :')
disp(GenEliteValue)
disp(' --------------------------------')
disp(' Esteban Daro Marks, UTN FRCU, ARGENTINA')
disp(' email://pirateka@adinet.com.uy')
disp(' http://www.elementosdemaquinas.tk')
disp('      ')
disp('///////////////////////////////////////////////////////////////////////////')

